function out = comp_press_field_point_source(c,p0,x,y,z,x_s,y_s,z_s,t)

	% error checking to make sure that c,p0,x_s,y_s and z_s are 1X1 elements and not vectors
	if (~(isequal(size(c),size(p0),size(x_s),size(y_s),size(z_s),size(1))))
		error('Please check the input data');
		quit
	end

	[x,y,z,t]=ndgrid(x,y,z,t);		% ndimenional grid
	r=sqrt((x-x_s).^2 + (y-y_s).^2 + (z-z_s).^2);

	out=(p0/(4*pi))*diracdel(t- r/c)./r; %Equation 1
end