clear;clc;

c=1500;p0=1;x_s=0;y_s=0;z_s=0;
x=1e-3;y=1e-3;z=0;
t=0:1e-8:3e-6;

f0=10e6; stdev=50e-9; del_t=10e-9;
t2=-4*stdev:del_t:4*stdev;

p=comp_press_field_point_source(c,p0,x,y,z,x_s,y_s,z_s,t);
p=reshape(p(1,1,1,:),[length(t) 1]); % converting 4d array to a vector

G=comp_Gaussian_tone_burst(f0,stdev,del_t);

s=conv(p,G,'same'); %Equation 3
%convolving to get central part with same dimensions as p

plot(t*1e6,p,t*1e6,s);
title('Pressure as function of time for an acoustic');
xlabel('Time[us]'); ylabel('Pressure[Pa]');
legend('p(x,y,z,t)','s(x,y,z,t)')