clear;clc;

c=1500;p0=1;x_s=0;y_s=0;z_s=0;
x=1e-3;y=1e-3;z=0;
t1=0:1e-8:3e-6-1e-7;

del_t=10e-9;

f0=(10:6:40)*1e6;
stdev=(50:90:500)*1e-9;


%Looping over all frequency and sigma values

for i=1:6

	t2=-4*stdev(i):del_t:4*stdev(i);

	p=comp_press_field_point_source(c,p0,x,y,z,x_s,y_s,z_s,t1);
	p=reshape(p(1,1,1,:),[length(t1) 1]); % converting 4d array to a vector
	G=comp_Gaussian_tone_burst(f0(i),stdev(i),del_t);
	s=conv(p,G,'same'); % Equation 3
	% convolving to get central part with same dimensions as p

	n=length(s);

	yfft=abs(fftshift(fft(s))); % FFTshift shifts zero frequency components to centre of spectrum
	freq=(0:1/del_t:(n/2)/del_t)/n; 

	% figure
	subplot(2,3,i);
	yfft=yfft((n+1)/2:end); %Taking positive frequency amplitudes
	plot(freq*1e-6,yfft); %Converting Hertz to Mhz
	title(['f0 = ', num2str(f0(i)*1e-6), 'MHz, sigma = ', num2str(stdev(i)*1e9), 'ns']);
	xlabel('Time[us]'); ylabel('Pressure[Pa]');
end