clear;clc;

c=1500;p0=1;
x_s=0;y_s=0;z_s=0;

f0=10e6; stdev=50e-9; del_t=10e-9;

x=(-3:0.01:3)*1e-3;
y=(-3:0.01:3)*1e-3;
z=0;
t=0:1e-8:3e-6;

dimx=length(x);
dimy=length(y);
dimt=length(t);

p=comp_press_field_point_source(c,p0,x,y,z,x_s,y_s,z_s,t);
G=comp_Gaussian_tone_burst(f0,stdev,del_t);

% Contents of this 4d array will be modified to obtain the required Gaussian burst response
s=ones(dimx,dimy,1,dimt);  

% This loop is used to obtain time vectors corresponding a specific x and y, and to convolve it to obtain
% s at that point
for i=1:dimx
  for j=1:dimy
    s(i,j,:)=conv(reshape(p(i,j,1,:),[dimt 1]),G,'same'); %Equation 3
  end
end

subplot(1,2,1); pcolor(x*1e3,y*1e3,p(:,:,1,find(t==1e-6)));shading flat;colorbar;  %Shading flat disables pixel interpolation 
title('Impulse response');xlabel('x[mm]');ylabel('y[mm]');

subplot(1,2,2); pcolor(x*1e3,y*1e3,s(:,:,1,find(t==1e-6)));shading flat;colorbar;
title('Field generated by Gaussian burst');xlabel('x[mm]');ylabel('y[mm]');