clear;clc;

c=1500;p0=1;
y_s=0;z_s=0;

f0=10e6; stdev=50e-9; del_t=10e-9;

x=(-2:0.05:2)*1e-3;
y=(0:0.05:4)*1e-3;
z=0;
t=0:1e-8:4e-6;

dimx=length(x);
dimy=length(y);
dimt=length(t);

%Contents of this 4d array will be modified to get the actual p
p=zeros(dimx,dimy,1,dimt);

count=0;   %Comment this out for solution that follows assignment solution
for x_s=(-0.5:0.05:0.5)*1e-3
	count=count+1;	%Comment this out for solution that follows assignment solution
	p=p+comp_press_field_point_source(c,p0,x,y,z,x_s,y_s,z_s,t);
end
p=p/count;	%Comment this out for solution that follows assignment solution

G=comp_Gaussian_tone_burst(f0,stdev,del_t);

s=ones(dimy,dimx,dimt);

% This loop is used to obtain time vectors corresponding a specific x and y, and to convolve it to obtain
% s at that point
for i=1:dimx
  for j=1:dimy
    s(j,i,:)=conv(reshape(p(i,j,1,:),[dimt 1]),G,'same'); %Equation 3
  end
end

pcolor(x*1e3,y*1e3,s(:,:,find(t==1e-6)));shading flat;colorbar;
title('Field generated by line source at t= 1us');xlabel('x[mm]');ylabel('y[mm]');