clear;clc;

c=1500;p0=1;
y_s=0;z_s=0;

f0=10e6; stdev=50e-9; del_t=10e-9;

x=(-2:0.05:2)*1e-3;
y=(0.05:0.05:2)*1e-3;
z=0;
t=0:10e-9:4e-6;

dimx=length(x);
dimy=length(y);
dimt=length(t);

src_sep=[1 5:5:200]*1e-3;  %All the source seperation distances in mm

%Contents of this 4d array will be modified to get the actual p
s=ones(dimy,dimx,dimt,length(src_sep));  %The fourth dimension corresponds to different source seperation differences

G=comp_Gaussian_tone_burst(f0,stdev,del_t);

%Looping over all the source seperation distances
for id=1:length(src_sep)
	p=zeros(dimx,dimy,1,dimt);
	
	count=0;%Comment this out for solution that follows assignment solution
	
	for x_s=union(0:-1*src_sep(id):-0.5, 0:src_sep(id):0.5)*1e-3
	%Above, x_s is written that way to ensure that the geometric centre of source points lie at x=0;
	% For example, x_s= -500um:195 um:500 um would give mean value of -12.5
	% But x_s=union(0:-195:-500, 0:195:500) makes sure that mean value stays at 0

		count=count+1;%Comment this out for solution that follows assignment solution
		p=p+comp_press_field_point_source(c,p0,x,y,z,x_s,y_s,z_s,t);
	end

	p=p/count;%Comment this out for solution that follows assignment solution

	for i=1:dimx
	  for j=1:dimy
	    s(j,i,:,id)=conv(reshape(p(i,j,1,:),[dimt 1]),G,'same');
	  end
	end
end

err=zeros(1,size(s,4));

t_1us=find(t==1e-6);
rms_ref=sqrt(mean2(s(:,:,t_1us,1).^2));
for i=2:size(s,4)  %Error at source seperation 1 um is 0
	err(1,i)=100*sqrt(mean2((s(:,:,t_1us,i)-s(:,:,t_1us,1)).^2))/rms_ref; %Equation 4
end

writerObj = VideoWriter('Task7_video.avi');
writerObj.FrameRate = 8;
open(writerObj); 
 
for i=1:size(s,4)
	pause(0.1);
    pcolor(x*1e3,y*1e3,s(:,:,t_1us,i));shading flat;colorbar;
 	title(['Source spacing= ',num2str(src_sep(i)*1e3),' um, error= ',num2str(err(1,i)),' %']);
 	xlabel('x[mm]');ylabel('y[mm]');
    frame = getframe(gcf);
    writeVideo(writerObj, frame);
end
close(writerObj)